<!-- Spinner -->
<ngx-spinner [name]='"workloads_render"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<div class="card dialog-content" style="padding: 2%">
    <!-- Title -->
    <mat-label style="display: flex; justify-content: center; margin-top: 4%">
        <mat-icon style="margin-right: 9px">monitor</mat-icon>
        <h1>Create Workload Instace</h1>
    </mat-label>

    <!-- Create Workload Form -->
    <form [formGroup]="renderForm" novalidate (ngSubmit)="submitRenderForm(renderForm.value)">
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div class="col-lg-12 col-xl-10">
                <!-- Form First Row -->
                <div class="row">
                    <!-- Field: Release Name -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Release Name *</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="release_name" name="release_name"
                                formControlName="release_name" matInput type="text" placeholder="Type Release Name"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.release_name">
                                <span class="error-message" *ngIf="
                                    renderForm.get('release_name').hasError(validation.type) &&
                                    (renderForm.get('release_name').dirty ||
                                    renderForm.get('release_name').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                    <!-- Field: Ingress Enabled -->
                    <div *ngIf="data.id.ingress_support" class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Ingress Enabled</label><br>
                        <mat-form-field class="text-form-field-targ" appearance="fill">
                            <mat-select name="ingress_enabled" formControlName="ingress_enabled">
                                <mat-option [value]="true">True</mat-option>
                                <mat-option [value]="false">False</mat-option>
                            </mat-select>
                        </mat-form-field><br>
                    </div>
                </div>
                <!-- Form Second Row -->
                <div class="row" *ngIf="hasRole('nemo_provider')">
                    <!-- Field: Cluster Name -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Cluster Name</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input id="cluster_name" name="cluster_name"
                                formControlName="cluster_name" matInput type="text" placeholder="Type Cluster Name"/>
                        </mat-form-field><br>
                    </div>
                    <!-- Field: Namespace -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Namespace</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input id="namespace" name="namespace"
                                formControlName="namespace" matInput type="text" placeholder="Type Namespace"/>
                        </mat-form-field><br>
                    </div>
                </div>
                <!-- Form Third Row -->
                <div class="row">
                    <!-- Field: Values Override -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Values Override</label><br>
                        <mat-form-field class="text-form-field" appearance="fill" style="width: 100%;">
                            <textarea id="values_override" name="values_override" formControlName="values_override"
                                      matInput placeholder="Enter values override here..." rows="1"></textarea>
                        </mat-form-field><br>
                    </div>

                    <!-- Field: Include CRDS -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Include CRDS</label><br>
                        <mat-form-field class="text-form-field-targ" appearance="fill">
                            <mat-select name="include_crds" formControlName="include_crds">
                                <mat-option [value]="true">True</mat-option>
                                <mat-option [value]="false">False</mat-option>
                            </mat-select>
                        </mat-form-field><br>
                    </div>

                </div>
                <!-- Form Fourth Row -->
                <div class="row">
                    <!-- Field: Is Upgrade -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Is Upgrade</label><br>
                        <mat-form-field class="text-form-field-targ" appearance="fill">
                            <mat-select name="is_upgrade" formControlName="is_upgrade">
                                <mat-option [value]="true">True</mat-option>
                                <mat-option [value]="false">False</mat-option>
                            </mat-select>
                        </mat-form-field><br>
                    </div>

                    <!-- Field: No Hooks -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">No Hooks</label><br>
                        <mat-form-field class="text-form-field-targ" appearance="fill">
                            <mat-select name="no_hooks" formControlName="no_hooks">
                                <mat-option [value]="true">True</mat-option>
                                <mat-option [value]="false">False</mat-option>
                            </mat-select>
                        </mat-form-field><br>
                    </div>
                </div>
            </div>
        </div>

        <!-- Intents -->
        <div formArrayName="intents">
            <div *ngFor="let control of intents.controls; let i_intents = index" class="row intent_group">
                <div [formGroupName]="i_intents">
                    <!-- First Row: Intent Type & Delete -->
                    <div style="display: flex; justify-content: center;" class="row mb-10">
                        <!-- First Column -->
                        <div class="col-lg-6 col-xl-5">
                            <!-- Field: Intent Type  -->
                            <label class="col-lg-12 col-form-label text-lg">Intent Type *</label><br>
                            <mat-form-field class="text-form-field-2" appearance="fill">
                                <mat-select required id="intent_type" name="intent_type" formControlName="intent_type" placeholder="Select Intent Type">
                                    <mat-option *ngFor="let option of intentTypesOptions" [value]="option">
                                        {{ option }}
                                    </mat-option>
                                </mat-select>
                        
                                <!-- <mat-error *ngFor="let validation of incorrect_form_messages.intent_type">
                                    <span class="error-message" *ngIf="
                                        createIntentForm.get('intent_type').hasError(validation.type) &&
                                        (createIntentForm.get('intent_type').dirty ||
                                        createIntentForm.get('intent_type').touched)">
                                        {{ validation.message }}
                                    </span>
                                </mat-error> -->
                            </mat-form-field><br>  
                        </div>
                        <!-- Second Column -->
                        <div class="col-lg-6 col-xl-5 d-flex align-items-center justify-content-center">
                            <!-- Button: Remove Intent -->
                            <button type="button" mat-raised-button id="removeFormField_button" class="btn-rem-intent"
                                (click)="removeIntentForm(i_intents)" style="color: white; background-color: red;">
                                <mat-icon>delete</mat-icon> Remove Intent
                            </button>
                        </div>
                    </div>
                    <!-- Second Row: Dates -->
                    <div style="display: flex; justify-content: center;" class="row mb-10">
                        <div class="col-lg-6 col-xl-5">
                            <!-- Field: Start Time -->
                            <label class="col-lg-12 col-form-label text-lg">Start Date-time</label><br>
                            <mat-form-field class="datetime-form-field" appearance="fill">
                                <input matInput readonly [ngxMatDatetimePicker]="start_picker" placeholder="Choose start datetime" formControlName="start_time">
                                <mat-datepicker-toggle matSuffix [for]="$any(start_picker)"></mat-datepicker-toggle>
                                <ngx-mat-datetime-picker #start_picker [color]="'warn'"> </ngx-mat-datetime-picker>
                            </mat-form-field><br>
                        </div>
                        <div class="col-lg-6 col-xl-5">
                            <!-- Field: End Time -->
                            <label class="col-lg-12 col-form-label text-lg">End Date-time</label><br>
                            <mat-form-field class="datetime-form-field" appearance="fill">
                                <input matInput readonly [ngxMatDatetimePicker]="end_picker" placeholder="Choose end datetime" formControlName="end_time">
                                <mat-datepicker-toggle matSuffix [for]="$any(end_picker)"></mat-datepicker-toggle>
                                <ngx-mat-datetime-picker #end_picker [color]="'warn'"> </ngx-mat-datetime-picker>
                            </mat-form-field><br>
                        </div>
                    </div>

                    <!-- Target Labels -->
                    <div style="display: flex; justify-content: center;" class="row mb-10">
                        <div class="col-lg-12 col-xl-10">
                            <div class="row">
                                <div class="col-lg-4">
                                    <label class="col-lg-12 col-form-label text-lg">Target Name</label><br>
                                </div>
                                <div class="col-lg-2">
                                    <label class="col-lg-12 col-form-label text-lg">Target Condition</label><br>
                                </div>
                                <div class="col-lg-5">
                                    <label class="col-lg-12 col-form-label text-lg">Target Value</label><br>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- Targets -->
                    <div style="display: flex; justify-content: center;" class="row mb-10">
                        <div formArrayName="targets" class="col-lg-12 col-xl-10">
                            <div *ngFor="let target of getTargets(i_intents).controls; let iarr = index">
                                <div [formGroupName]="iarr">
                                    <div class="row">
                                        <div class="col-lg-4">
                                            <mat-form-field class="text-form-field-targ" appearance="fill">
                                                <input name="target_name"
                                                    formControlName="target_name" matInput type="text" placeholder="Type Target Name"/>    
                                            </mat-form-field><br>
                                        </div>
                                        <div class="col-lg-2">
                                            <mat-form-field class="text-form-field-targ" appearance="fill">
                                                <mat-select name="target_condition"
                                                            formControlName="target_condition" placeholder="Select Condition">
                                                    <mat-option *ngFor="let option of target_condition_Options" [value]="option">
                                                        {{ option }}
                                                    </mat-option>
                                                </mat-select>
                                            </mat-form-field><br>
                                        </div>
                                        <div class="col-lg-5">
                                            <mat-form-field class="text-form-field-targ" appearance="fill">
                                                <input name="target_value"
                                                    formControlName="target_value" matInput type="text" placeholder="Type Target Value"/>
                                            </mat-form-field><br>
                                        </div>
                                        <div class="col-lg-1">
                                            <button type="button" mat-raised-button id="removeFormField_button" class="btn-rem"
                                                (click)="removeTargetForm(i_intents, iarr)">
                                                <mat-icon>remove</mat-icon>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                                <!-- <mat-error *ngFor="let validation of incorrect_form_messages.targets">
                                    <span class="error-message" *ngIf=
                                        "control.hasError('incompleteTargetValidator') && (control.dirty)">
                                        {{ validation.message }}
                                    </span>
                                </mat-error> -->
                            </div>
                        </div>
                    </div>

                    <!-- Add Target Button -->
                    <div style="display: flex; justify-content: center;" class="row mb-10">
                        <div class="col-lg-12 col-xl-10" style="margin-bottom: 20px;">                    
                            <button type="button" mat-raised-button id="addFormFiel_button" class="btn-2"
                                (click)="addTargetForm(i_intents)">
                                <span class="indicator-label">
                                <a> Add Target </a>
                                </span>
                            </button>
                        </div>
                    </div> 
                </div>
            </div>
        </div>

    </form>

    <!-- Footer -->
    <div class="card-footer" style="display: flex; justify-content: end; background-color: white;">
        <div class="row">
            <div class="col-lg-22">
                <button type="button" mat-raised-button id="addIntent_button" class="btn-2"
                    (click)="addIntentForm()"> 
                    <span class="indicator-label">
                    <a> Create Intent Template </a>
                    </span>
                </button>

                <!-- Submit button -->
                <button mat-raised-button id="submit_button" class="btn-2"
                    type="submit" (click)="submitRenderForm(renderForm.value)">
                    <span class="indicator-label">
                    <a> Render </a>
                    </span>
                </button>

                <!-- Reset button -->                    
                <button (click)="resetRenderForm()" id="reset_button" mat-raised-button> 
                    Reset
                </button>
            </div>
        </div>



        <!-- <div class="row">
            <div class="col-lg-4">
                <button type="button" mat-raised-button id="addIntent_button" class="btn-2"
                    (click)="addIntentForm()">
                    <span class="indicator-label">
                    <a> Create Intent Template </a>
                    </span>
                </button>
            </div>
            <div class="col-lg-6">
                <div class="row display: flex; justify-content: end;">
                    <button mat-raised-button id="submit_button" class="btn-2"
                        type="submit" (click)="submitRenderForm(renderForm.value)">
                        <span class="indicator-label">
                        <a> Render </a>
                        </span>
                    </button>

                    <button (click)="resetRenderForm()" id="reset_button" mat-raised-button> 
                        Reset
                    </button>
                </div>
            </div>
        </div> -->



    </div>
</div>
